# TODO: remove

import subprocess
from functools import partial
from typing import Callable

clear = lambda: subprocess.run("clear")

class PyWizard:
    """
    Static object for managing the state of a wizard with a structure declared as a dict
    """
    root = None
    prompt = None
    inprompt = "> "
    clear = True
    stack = []

    @staticmethod
    def home(args: callable) -> None:
        args()

        PyWizard.stack = []
        PyWizard.run_wizard(PyWizard.root, PyWizard.prompt)

    @staticmethod
    def pop(args: callable = None) -> None:
        if args is not None and callable(args):
            args()
        pop_callee, pop_args = PyWizard.stack.pop()
        pop_callee(*pop_args)

    @staticmethod
    def confirm(args: callable, prompt: str = "Are you sure? y/N") -> None:
        print(prompt)
        inval = input("> ")
        if inval.lower() == "y" or inval.lower() == "yes":
            args()
        else:
            PyWizard.pop()

    @staticmethod
    def render_opts(options_list, prompt, inprompt, add_back: bool = True) -> int:
        print(prompt)
        [print(f" {i+1}.\t{opt}") for i, opt in enumerate(options_list)]
        if add_back:
            if len(PyWizard.stack) > 0:
                print("\n 0.\tBack")
            else:
                print("\n 0.\tQuit")
        try:
            out = int(input(inprompt))
        except:
            print(f"Invalid value, please input a number between 0-{len(options_list)}")
            return PyWizard.render_opts(options_list, prompt, inprompt)
        
        if PyWizard.clear:
            clear()
        return out

    @staticmethod
    def run_wizard(root: dict = None, prompt = None, set_root: bool = False) -> None:
        if PyWizard.root is None or set_root and root is not None:
            PyWizard.root = root
        if PyWizard.prompt is None or set_root and prompt is not None:
            PyWizard.prompt = prompt
        if root is None:
            cur_root = PyWizard.root
            options_list = PyWizard.root.keys()
            actions_list = list(PyWizard.root.values())
        else:
            cur_root = root
            options_list = root.keys()
            actions_list = list(root.values())

        if set_root:
            PyWizard.stack = []

        if prompt is not None:
            cur_prompt = prompt
        else:
            cur_prompt = PyWizard.prompt
        
        act = PyWizard.render_opts(options_list, cur_prompt, PyWizard.inprompt)
        if act != 0:
            action = actions_list[act - 1]
            PyWizard.stack.append((PyWizard.run_wizard, (cur_root, cur_prompt, ), ))
            if callable(action):
                return action()
            elif isinstance(action, dict):
                PyWizard.run_wizard(action, cur_prompt, False)
            else:
                raise ValueError(f"Unknown wizard action type: {type(action)}")
        else:
            if len(PyWizard.stack) > 0:
                PyWizard.pop()
            else:
                exit()

    @staticmethod
    def run_values_wizard(root: dict, data: dict = None, prompt = None, set_root: bool = False) -> None:
        options_list = list(root.keys())
        actions_list = list(root.values())

        # Make sure all keys exist in data
        for k in options_list:
            if k not in data.keys():
                data[k] = None

        # Values wizard action format: tuple[renderer: callable, value_getter: callable, post_func: callable]

        render_list = [o if not isinstance(root[o], tuple) else root[o][0](o, data[o]) for o in options_list]

        cur_prompt = prompt
        act = PyWizard.render_opts(render_list, cur_prompt, PyWizard.inprompt)
        if act != 0:
            PyWizard.stack.append((PyWizard.run_values_wizard, (root, data, prompt, False), ))
            action = actions_list[act - 1]
            opt = options_list[act - 1]
            if isinstance(action, dict):
                return PyWizard.run_values_wizard(action, data[opt], prompt, False)
            elif isinstance(action, tuple):
                action[1](data, opt)
                return action[2]()
            elif callable(action):
                return action(data=data, option=opt)
        else:
            if len(PyWizard.stack) > 0:
                PyWizard.pop()
            else:
                exit()


def get_value(arg: type, prompt, data, key):
    print(prompt)
    data[key] = arg(input("> "))

def values(args: type, prompt="New value: "):
    renderer = lambda o, d: "{} : {}".format(o, d)

    return renderer, partial(get_value, args, prompt), PyWizard.pop

def enum_setter(args: dict, data, key):
    opts_list = list(args.values())
    act = PyWizard.render_opts(opts_list, "Choose an option:\n", "> ")
    if act > 0 and act <= len(args.values()):
        data[key] = list(args.keys())[act - 1]

def enum_select(args: dict):
    """
    Takes a dict with the keys as the values to be stored and the values as the text to be displayed
    """
    renderer = lambda o, d: "{} : {}".format(o, str(args[d]))
    setter = partial(enum_setter, args)
    return renderer, setter, PyWizard.pop

def select_options(args: list, action: callable, new_prompt: str = None, display: callable = lambda x: x):
    new_wizard = {display(x): partial(action, x) for x in args}
    return PyWizard.run_wizard(new_wizard, new_prompt)

def home(args: callable):
    return partial(PyWizard.home, args)

def up(args: callable):
    return partial(PyWizard.pop, args)

def confirm(args: callable, prompt: str = "Are you sure? y/N") -> Callable:
    return partial(PyWizard.confirm, args, prompt)
