import ctypes as ct
from enum import IntEnum

from .voxl_utils import is_voxl

if not is_voxl():
    raise Exception("libmodal_journal only supports voxl platform")

libmodal_journal = ct.CDLL("libmodal_journal.so")

class ModalJournalLevel(IntEnum):
    VERBOSE = 0 # Log everything
    DEBUG = 1 # Enable >= debugl ogs
    WARNING = 2 # Enable >= warning logs(default)
    ERROR = 3 # Enable >= error logs
    PRINT = 4 # Enable only print logs


modal_journal_set_level  = libmodal_journal.M_JournalSetLevel
modal_journal_set_level.argtypes = [ct.c_int]
modal_journal_set_level.restype  = None


modal_journal_print  = libmodal_journal.M_JournalPrint
modal_journal_print.argtypes = [ct.c_int, ct.c_char_p] # Variadic arguments don't need to be specified here
modal_journal_print.restype  = None

